OBJS=$(patsubst %cpp,%o,$(wildcard *.cpp))
OBJSD=$(patsubst %cpp,%d,$(wildcard *.cpp))
#OBJS=$(patsubst %cpp,%o,$(wildcard *.cpp)) $(patsubst %c,%o,$(wildcard *.c))
#OBJSD=$(patsubst %cpp,%d,$(wildcard *.cpp)) $(patsubst %c,%d,$(wildcard *.c))

.SUFFIXES: .cpp
#.SUFFIXES: .cpp .c

UNAME_S := $(shell uname -s)

CC=g++
CFLAGS+=-std=c++11 -O3 -ggdb -I../include -Wall -fmessage-length=0 -Wno-write-strings -Wno-delete-non-virtual-dtor -fPIC -MMD -MP
ifeq ($(UNAME_S),FreeBSD)
CFLAGS+= -Wl,-rpath=/usr/local/lib/gcc10
endif
CPPFLAGS=

.cpp.o:
	$(CC) -c $(CFLAGS) $(CPPFLAGS) -o $@ $<
#.c.o:
#	$(CC) -c $(CFLAGS) $(CPPFLAGS) -o $@ $<
	
BUILD=$(CC) -L/lib -pthread -Wl,--no-as-needed -ldl -shared -o $@ $(OBJS) $(USER_OBJS) $(LIBS)
ifeq ($(UNAME_S),Linux)
BUILD+= -luuid
endif

# All Target
all: librtx_stdlib.so

# Tool invocations
librtx_stdlib.so: $(OBJS) $(USER_OBJS)
	$(BUILD)

# Other Targets
clean:
	-$(RM) $(LIBRARIES) $(CC_DEPS) $(C++_DEPS) $(C_UPPER_DEPS) $(CXX_DEPS) $(OBJS) $(OBJSD) $(CPP_DEPS) $(C_DEPS) librtx_stdlib.so
	-@echo ' '

.PHONY: all clean dependents
